/**
 * Header       LcdMenuControlButton.h
 * Author       2021-02-02 Charles Geiser (https://www.dodeka.ch)
 * 
 * Purpose      Declaration of the class LcdMenuControlButton
 * 
 * Constructor
 * arguments    pin         Pin to which the menu button is connected to (INPUT_PULLUP)
 *              &menu       A reference to an instance of LcdMenu 
 */
 
#ifndef _LCDMENUCONTROLBUTTON_H_
#define _LCDMENUCONTROLBUTTON_H_

#include "ButtonDebounced.h"
#include "LcdMenu.h"

class LcdMenuControlButton: public ButtonDebounced
{
  public:
    LcdMenuControlButton(uint8_t pin, LcdMenu &menu) : ButtonDebounced(pin), _menu(menu) 
    { 
      setup(); // call setup() of the base class
    }

  protected:
    // Virtual methods of the base class
    void onClick();
    void onLongClick();
    void onDoubleClick();

  private:
    LcdMenu &_menu;
    bool _actionDone = false;
};
#endif